AC_DEFUN(AC_PATH_LIBXPM,
[
  AC_REQUIRE_CPP()
  AC_MSG_CHECKING(for X Pixmap Library)
  have_xpm=no
  eval "$ac_cv_have_libxpm"
  if test "x$xpm_includes" != x&& test "x$xpm_libraries" != x; then
     have_xpm=yes;
  else
    AC_CACHE_VAL(ac_cv_have_libxpm,[
      ac_xpm_includes=NO
      ac_xpm_libraries=NO
      
      AC_PATH_LIBXPM_DIRECT
      
      if test "$ac_xpm_includes" = NO || test "$ac_xpm_libraries" = NO; then
         ac_cv_have_libxpm="have_xpm=no"
      else
         ac_cv_have_libxpm="have_xpm=yes \
  	 ac_xpm_includes=$ac_xpm_includes ac_xpm_libraries=$ac_xpm_libraries"
	 
      fi
    eval "$ac_cv_have_libxpm"
    
    ])
 fi
 if test "$have_xpm" != yes; then
    AC_MSG_RESULT($have_xpm)
 else
  test "x$xpm_includes" = x && xpm_includes=$ac_xpm_includes
  test "x$xpm_libraries" = x && xpm_libraries=$ac_xpm_libraries

  ac_cv_have_xpm="have_xpm=yes \
		ac_xpm_includes=$xpm_includes ac_xpm_libraries=$xpm_libraries"
  AC_MSG_RESULT([libraries $xpm_libraries, headers $xpm_includes ])
fi

])

AC_DEFUN(AC_LOCATE_HEADER,
[
 ac_header_found=no
 AC_TRY_CPP([#include <$1>],
 [ac_header_includes=
  ac_header_found=yes],
 [
  for ac_dir in               \
    /usr/X11/include          \
    /usr/X11R6/include        \
    /usr/X11R5/include        \
    /usr/X11R4/include        \
                              \
    /usr/include/X11          \
    /usr/include/X11R6        \
    /usr/include/X11R5        \
    /usr/include/X11R4        \
                              \
    /usr/local/X11/include    \
    /usr/local/X11R6/include  \
    /usr/local/X11R5/include  \
    /usr/local/X11R4/include  \
                              \
    /usr/local/include/X11    \
    /usr/local/include/X11R6  \
    /usr/local/include/X11R5  \
    /usr/local/include/X11R4  \
                              \
    /usr/X386/include         \
    /usr/x386/include         \
    /usr/XFree86/include/X11  \
                              \
    /usr/include              \
    /usr/local/include        \
    /usr/unsupported/include  \
    /usr/athena/include       \
    /usr/local/x11r5/include  \
    /usr/lpp/Xamples/include  \
                              \
    /usr/openwin/include      \
    /usr/openwin/share/include \
    ; \
  do
    if test -r "$ac_dir/$1"; then
      ac_header_includes=$ac_dir
      ac_header_found=yes
      break
    fi
  done
  ])
])
AC_DEFUN(AC_LOCATE_LIB,
[
 AC_LANG_SAVE
 AC_LANG_C
 ac_save_LIBS="$LIBS"
 LIBS="$LIBS -l$1"
 ac_save_CFLAGS="$CFLAGS"
 CFLAGS=""
 
 ac_library_found=no
 
 AC_TRY_LINK(,[ $2(); ],
 [ 
   LIBS="$ac_save_LIBS" 
   CFLAGS="$ac_save_CFLAGS"
   AC_LANG_RESTORE
   ac_libraries= 
   ac_library_found=yes
 ],
 [ 
   LIBS="$ac_save_LIBS"
   CFLAGS="$ac_save_CFLAGS"
   for ac_dir in \
    /usr/X11/lib          \
    /usr/X11R6/lib        \
    /usr/X11R5/lib        \
    /usr/X11R4/lib        \
                          \
    /usr/lib/X11          \
    /usr/lib/X11R6        \
    /usr/lib/X11R5        \
    /usr/lib/X11R4        \
                          \
    /usr/local/X11/lib    \
    /usr/local/X11R6/lib  \
    /usr/local/X11R5/lib  \
    /usr/local/X11R4/lib  \
                          \
    /usr/local/lib/X11    \
    /usr/local/lib/X11R6  \
    /usr/local/lib/X11R5  \
    /usr/local/lib/X11R4  \
                          \
    /usr/X386/lib         \
    /usr/x386/lib         \
    /usr/XFree86/lib/X11  \
                          \
    /usr/lib              \
    /usr/local/lib        \
    /usr/unsupported/lib  \
    /usr/athena/lib       \
    /usr/local/x11r5/lib  \
    /usr/lpp/Xamples/lib  \
    /lib/usr/lib/X11	  \
                          \
    /usr/openwin/lib      \
    /usr/openwin/share/lib \
    ; \
do
  for ac_extension in a so sl; do
    if test -r $ac_dir/lib$1.$ac_extension; then
      ac_libraries=$ac_dir
      ac_library_found=yes
      AC_LANG_RESTORE
      break 
    fi
  done
done])
])


AC_DEFUN(AC_PATH_LIBXPM_DIRECT,
[
if test "$ac_xpm_includes" = NO; then
 AC_TRY_CPP([#include <X11/xpm.h>],
 [ac_xpm_includes=],
 [
  for ac_dir in               \
    /usr/X11/include          \
    /usr/X11R6/include        \
    /usr/X11R5/include        \
    /usr/X11R4/include        \
                              \
    /usr/include/X11          \
    /usr/include/X11R6        \
    /usr/include/X11R5        \
    /usr/include/X11R4        \
                              \
    /usr/local/X11/include    \
    /usr/local/X11R6/include  \
    /usr/local/X11R5/include  \
    /usr/local/X11R4/include  \
                              \
    /usr/local/include/X11    \
    /usr/local/include/X11R6  \
    /usr/local/include/X11R5  \
    /usr/local/include/X11R4  \
                              \
    /usr/X386/include         \
    /usr/x386/include         \
    /usr/XFree86/include/X11  \
                              \
    /usr/include              \
    /usr/local/include        \
    /usr/unsupported/include  \
    /usr/athena/include       \
    /usr/local/x11r5/include  \
    /usr/lpp/Xamples/include  \
                              \
    /usr/openwin/include      \
    /usr/openwin/share/include \
    ; \
  do
    if test -r "$ac_dir/X11/xpm.h"; then
      ac_xpm_includes=$ac_dir
      break
    fi
  done])
fi

if test "$ac_xpm_libraries" = NO; then
 
 ac_save_LIBS="$LIBS"
 
 LIBS="$LIBS -lXpm"
 
 ac_save_CFLAGS="$CFLAGS"
 
 CFLAGS=""
 
 AC_TRY_LINK(,[ XpmCreateImageFromData(); ],
 [ 
   LIBS="$ac_save_LIBS" 
   CFLAGS="$ac_save_CFLAGS"
   ac_xpm_libraries= 
 ],
 [ 
   LIBS="$ac_save_LIBS"
   CFLAGS="$ac_save_CFLAGS"
   for ac_dir in `echo "$ac_xpm_includes" | sed s/include/lib/` \
    /usr/X11/lib          \
    /usr/X11R6/lib        \
    /usr/X11R5/lib        \
    /usr/X11R4/lib        \
                          \
    /usr/lib/X11          \
    /usr/lib/X11R6        \
    /usr/lib/X11R5        \
    /usr/lib/X11R4        \
                          \
    /usr/local/X11/lib    \
    /usr/local/X11R6/lib  \
    /usr/local/X11R5/lib  \
    /usr/local/X11R4/lib  \
                          \
    /usr/local/lib/X11    \
    /usr/local/lib/X11R6  \
    /usr/local/lib/X11R5  \
    /usr/local/lib/X11R4  \
                          \
    /usr/X386/lib         \
    /usr/x386/lib         \
    /usr/XFree86/lib/X11  \
                          \
    /usr/lib              \
    /usr/local/lib        \
    /usr/unsupported/lib  \
    /usr/athena/lib       \
    /usr/local/x11r5/lib  \
    /usr/lpp/Xamples/lib  \
    /lib/usr/lib/X11	  \
                          \
    /usr/openwin/lib      \
    /usr/openwin/share/lib \
    ; \
do
  for ac_extension in a so sl; do
    if test -r $ac_dir/libXpm.$ac_extension; then
      ac_xpm_libraries=$ac_dir
      break 2
    fi
  done
done])
fi
])

AC_DEFUN(AC_CHECK_EXPAT,
[
  ac_have_expat=no
  
  AC_MSG_CHECKING([for expat])
  AC_LOCATE_HEADER(expat.h)
  AC_LOCATE_LIB(expat,XML_Parse)
  if test "$ac_header_found" = "no" || test "$ac_library_found" = "no"; then
  	AC_MSG_RESULT([no])
  else
  	ac_have_expat=yes
  	AC_MSG_RESULT([yes])
  fi
])
AC_DEFUN(AC_CHECK_XMLTOK,
[
  ac_have_xmltok=no
  
  AC_MSG_CHECKING([for xmltok])
  AC_LOCATE_HEADER(xmltok/xmltok.h)
  AC_LOCATE_LIB(xmltok,XmlInitEncoding)
  if test "$ac_header_found" = "no" || test "$ac_library_found" = "no"; then
  	AC_MSG_RESULT([no])
  else
  	ac_have_xmltok=yes
  	AC_MSG_RESULT([yes])
  fi
])
