/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "App.h"
#include "Config.h"
#include "../gtkconfig/GCMain.h"
#include <unistd.h>
#include <sys/signal.h>
#include <sys/wait.h>

dstring App::failcommand;
int App::ptime;
int App::configuring = 0;
int App::command_running = 0;
list<Entity*> App::Items;

void App::Init()
{

    ConfigNode *text = Config::NewUniqueNODE("text");

    text->NewPROPERTY( ConfigProperty("oktext","All Systems OK!"));
    text->NewPROPERTY( ConfigProperty("selecttext","Please Select the Host"));
    text->NewPROPERTY( ConfigProperty("errortext","System Failure"));

    *Config::NewUniqueNODE("fail")->NewPROPERTY("respawn")="10";
    *Config::NODE("fail")->NewPROPERTY("enabled")="0";

    signal(SIGCHLD, &chld_signal);
}
/*
void App::RunConfig()
{
    visual->Configure();
    DEBUG(5,"Running configurator\n");
    if (!configuring) {
	cw = new ConfigWindow();
	cw->SetCloseNotify(&ConfigEnd, (void*)this);
	cw->show();
        configuring=1;
    }
}

void App::ConfigEnd()
{
    delete(cw);
    configuring = 0;
}

 */
void App::periodic(void)
{
    if (command_running) {
	DEBUG(1,"Woops - Seems your last command did not exit in time. Either increase "
              " the respawn time or check out what's happening\n");
	return ;
    }
    try {
        dstring failcommand;
	failcommand =Config::NODE("fail")->PROPERTY("command")->VALUE();
	if (Config::NODE("fail")->PROPERTY("enabled")->VALUE() == "1") {
	    command_running = 1;
	    switch (fork()) {
	    case 0:
		execl("/bin/sh","/bin/sh","-c", failcommand.Char(),0);
	    default:
		break;
	    }
	}
    } catch (...) {}
    return ;
}


void App::chld_signal(int sig)
{
    while (waitpid(0, (int *) (NULL), (WNOHANG | WUNTRACED)) > 0);
    command_running = 0;
}
