/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "DString.h"
#include <string.h>

dstringtokenizer::dstringtokenizer(const dstring&s, const dstring &t):
    tokens(t), str(s)
{
    position = 0;
}
bool dstringtokenizer::end()
{
    return (unsigned)position > str.length();
}
dstring dstringtokenizer::next()
{
    int dindex;
    dindex = str.find_first_of(tokens, position);
    if (dindex) {
        int spos=position;
	position = dindex+1;
        return str.substr(spos, dindex-spos);
    }
    return dstring();
}
dstring dstringtokenizer::next(const dstring &t)
{
    tokens = t;
    return next();
}
int dstringtokenizer::count()
{
    // Not implemented
    throw;
}
unsigned char dstringtokenizer::last_delimiter()
{
    throw;
}
int toint(const dstring&s)
{
    long l;
    l = strtol(s.c_str(), (char**)0, 10);
    if (l==LONG_MIN || l==LONG_MAX)
	throw Error("NaN");
    return (int)l;
};

