/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "Timeout.h"
#include "TimeVal.h"

Timeout::Timeout(int t, int seconds, int milisseconds, SigC::Slot0<void> cb,int idd )
    : due_time(seconds,milisseconds), insert_time()
{
    handler = cb;
//    data = d;
    type = t;
    s=seconds;
    us=milisseconds;
    id = idd;
};

void Timeout::Reset()
{
    insert_time = due_time;
    due_time+=TimeVal(s,us);
}
bool Timeout::IsPersistent() const
{
    return type==Persistent;
}

bool Timeout::IsDue() const
{
    return due_time<ClockTime();
}
TimeVal Timeout::TimeTo() const
{
    TimeVal t = due_time-ClockTime();
    if (t.tv_sec<0) {
	t=0;
    }
    return t;
}
int Timeout::Call()
{
    TimeVal Offset = ClockTime() - insert_time;
    //fprintf(stderr,"Calling with offset %ld %ld\n",
    //	Offset.tv_sec, Offset.tv_usec);
    Offset+=insert_time-due_time;
    //fprintf(stderr,"Difftime offset %ld %ld\n",
	 //       Offset.tv_sec, Offset.tv_usec);

    handler.call();
}
