/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms foof the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "Classes.h"
#include "config.h"
#include "Config.h"
#include "Entity.h"
#include "debug.h"
#include <dlfcn.h>

typedef Configurable* (*cfgr)(void);

void Classes::open_class(const string &c)
{
        void *handler = dlopen(c.c_str(),
			   RTLD_LAZY|RTLD_GLOBAL);
    if (handler==0) {
	DEBUG(1, "Cannot open: %s\n", dlerror());
	throw Error("Error");
    }

    void *fcn;

    fcn = dlsym(handler,"createclass__Fv");
    if (fcn==0) {
	DEBUG(1, "Cannot open: %s\n", dlerror());
	throw Error("Error");
    }

    Config::RegisterClass( ((cfgr)fcn)() );
}

void Classes::Init()
{
    open_class ( VISUAL_LIBDIR "/libmonitorit_class_pinger.so" );
    open_class ( VISUAL_LIBDIR "/libmonitorit_class_tcp.so" );
}

