/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "GCMain.h"

#include <gtk--/entry.h>
#include <gtk--/checkbutton.h>
#include <gtk--/clist.h>
#include <gtk--/spinbutton.h>
#include "debug.h"
#include "Entity.h"
#include "Config.h"

void ConfigWindow::on_save1_activate()
{   
}

void ConfigWindow::on_quit1_activate()
{   
}

void ConfigWindow::on_CommonOKText_changed()
{
    //item("monitor/text:oktext")->set_value( CommonOKText->get_text() );
}

void ConfigWindow::on_CommonSelectText_changed()
{
    //item("monitor/text:selecttext")->set_value(CommonSelectText->get_text());
}

void ConfigWindow::on_CommonErrorText_changed()
{
    //item("monitor/text:errortext")->set_value(CommonErrorText->get_text());
}

void ConfigWindow::on_CommonCheckRun_toggled(const gchar *user_data)
{
    CommonTextEvent->set_editable(CommonCheckRun->get_active());
}

void ConfigWindow::on_CommonTextEvent_changed()
{   
}
void ConfigWindow::on_RespawnTime_changed()
{

}

void ConfigWindow::on_EntityList_select_row(gint row, gint column, GdkEvent *event)
{
    selrow = row;
}
void ConfigWindow::on_EntityList_unselect_row(gint row, gint column, GdkEvent *event)
{
    selrow = -1;
}

void ConfigWindow::on_add_button_clicked(const gchar *user_data)
{
    ChooseClass();
}

void ConfigWindow::on_EntityDeleteButton_clicked(const gchar *user_data)
{   
}

void ConfigWindow::on_EntityEditButton_clicked(const gchar *user_data)
{
    /* Get from notebook list */
    //DEBUG(5,"Sel %d %s\n", selrow, ((Entity*)EntityList->row(selrow).get_data())->VisualName().Char());
    if (selrow>=0) {
	//((Entity*)EntityList->row(selrow).get_data())->Edit();
	Entity *ent =(Entity*)EntityList->row(selrow).get_data();

        //ent->Edit();

	WindowData *data = createWindow( ent->Edit(), ent, ent->Class(),
					 slot( this, &ConfigWindow::on_APEOKButton_clicked ) );
    }
}

WindowData *ConfigWindow::createWindow( ConfigurableItemList *list, Entity *ent, Configurable *cls,
					const SigC::Slot1<void,WindowData*> & func )
{
    WindowData *data = new WindowData;
    data->eclass = cls;
    data->list = list;
    data->entity = ent;
    data->b = build_from_citemlist( data->list );

    data->w = new Gtk::Window(GTK_WINDOW_TOPLEVEL);
    data->w->set_modal( true );
    data->APEOKButton = manage(new class Gtk::Button("OK"));
    data->APECancelButton = manage(new class Gtk::Button("Cancel"));

    data->APEHBoxButtons = manage(new class Gtk::HBox(false, 0));
    data->APEVBoxMain = manage(new class Gtk::VBox(false, 0));

    data->APEVBoxMain->pack_start(*data->b, true, true, 0);
    data->APEOKButton->set_usize(100, -1);
    data->APECancelButton->set_usize(100, -1);

    data->APEHBoxButtons->set_border_width(8);
    data->APEHBoxButtons->pack_start(*data->APEOKButton, true, false, 0);
    data->APEHBoxButtons->pack_start(*data->APECancelButton, true, false, 0);

    data->APEVBoxMain->pack_start(*data->APEHBoxButtons, false, true, 0);
    DEBUG(5,"Adding class box to container\n");

    data->APEVBoxMain->show();

    DEBUG(5,"Adding main box to window\n");
    data->w->add( *data->APEVBoxMain );
    data->APEVBoxMain->show();
    data->APEHBoxButtons->show();
    data->APEOKButton->show();
    data->APECancelButton->show();
    data->b->show();
    data->w->show();

    data->APECancelButton->clicked.connect( SigC::bind(
						       SigC::slot(static_cast<class ConfigWindow*>(this),
								  &ConfigWindow::on_APECancelButton_clicked),
						       data)
					  );
    data->APEOKButton->clicked.connect( SigC::bind(func, data ) );

    data->w->destroy.connect( SigC::bind(
					 SigC::slot(static_cast<class ConfigWindow*>(this),
						    &ConfigWindow::on_APEWindow_destroy),
					 data)
			    );

}




void ConfigWindow::on_APECancelButton_clicked(WindowData *data)
{
    DEBUG(1,"Cancel\n");
    //delete ( data->list );
    delete ( data->w );
    //delete ( data );
}
void ConfigWindow::on_APEWindow_destroy(WindowData *data)
{
    DEBUG(1,"Destroy\n");
    delete ( data->list );
    delete ( data );
}

void ConfigWindow::on_APEOKButton_clicked(WindowData *data)
{
    try {
	data->eclass->ApplyEdit( data->list, data->entity );
	data->w->destroy();
        ReloadEntities();
    } catch (Error e) {
        message(e.error);
    }
}
void ConfigWindow::on_APEOKButton_clicked_ADD(WindowData *data)
{
    try {
	data->eclass->ApplyAdd( data->list );
	data->w->destroy();
	ReloadEntities();
    } catch (Error e) {
        message(e.error);
    }
}


void ConfigWindow::on_PingerSpinYellow_changed()
{   
}

void ConfigWindow::on_PingerSpinRed_changed()
{   
}

gint ConfigWindow::on_ConfigWindow_focus_in_event(GdkEventFocus *ev)
{   return 0;
}

gint ConfigWindow::on_ConfigWindow_delete_event(GdkEventAny *)
{
    DEBUG(5,"Here we are");
    on_ConfigWindow_close();
    return 0;
}

void ConfigWindow::on_ConfigWindow_show()
{   
}

void ConfigWindow::on_ConfigWindow_close()
{
    DEBUG(5,"Here we are");

    close_notify.call(cndata);

}


void ConfigWindow::on_okButton_clicked()
{
    SaveData();
    on_ConfigWindow_close();
    destroy();
}

void ConfigWindow::on_cancelButton_clicked()
{
    on_ConfigWindow_close();
    destroy();
}


void ConfigWindow::Entry_Changed( Gtk::Entry *entry, CItemString *s)
{
    DEBUG(9,"Entry Changed\n");
    s->set_value( entry->get_text() );
}
void ConfigWindow::Spin_Changed( Gtk::SpinButton *entry, CItemInteger *s)
{
    DEBUG(9,"Spin Changed\n");
    s->set_value( intstr(entry->get_value_as_int()) );
}
void ConfigWindow::Check_Changed( Gtk::CheckButton *entry, CItemBoolean *s)
{
    DEBUG(9,"Check Changed\n");
    if (entry->get_active())
	s->set_value("true");
    else
        s->set_value("false");
}

void ConfigWindow::Dependable_Toggle( Gtk::CheckButton *c,  pair<Gtk::Widget*, CItemBoolean *> *v )
{
    DEBUG(9,"Dependable Changed! %p %p %p\n",c,v->first,v->second);
    
    Check_Changed ( c, v->second );

    if (v->second->value() == "true" ) {
	v->first->set_flags(GTK_SENSITIVE);
        v->first->set_state(GTK_STATE_NORMAL);
    } else {
	v->first->set_state(GTK_STATE_INSENSITIVE);
    }
}
void ConfigWindow::Dependable_Destroy( pair<Gtk::Widget *, CItemBoolean *> * p)
{
    DEBUG(9,"Dependable Destroy %p\n",p );
    delete ( p );
}