/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "config.h"
#include "GCMain.h"
#include <gtk--/list.h>
#include <gtk--/combo.h>
#include <gtk--/menu.h>
#include <gtk--/label.h>
#include <gtk--/table.h>
#include <gtk--/frame.h>
#include <gtk--/checkbutton.h>
#include <gtk--/entry.h>
#include <gtk--/box.h>
#include <gtk--/spinbutton.h>
#include <gtk--/adjustment.h>
#include <gtk--/clist.h>
#include <gtk--/scrolledwindow.h>
#include <gtk--/button.h>
#include <gtk--/notebook.h>
#include <gtk--/base.h>
#include "Config.h"
#include "Entity.h"
#include "App.h"

void ConfigWindow::CreateDialog( const string &str, DialogType type)
{
    Gtk::Window *window;
    window = new Gtk::Window(GTK_WINDOW_DIALOG);
    Gtk::Box *box1 = new Gtk::VBox(true, 0);
    Gtk::Label *label1 =  new Gtk::Label(str.c_str());
    Gtk::Button *okButton = manage(new class Gtk::Button("OK"));

    box1->pack_start( *label1, true, true, 0 );
    box1->pack_start( *okButton, false, false, 0 );
    window->add( *box1 );

    label1->show();
    okButton->show();
    box1->show();
    window->show();
}
ConfigWindow *newConfigWindow()
{
    return new ConfigWindow();
}


void ConfigWindow::ReloadEntities()
{
    list<Entity*>::iterator it;
    EntityList->rows().clear();

    int row = 0;
    for (it=App::GetItems().begin();
	 it!=App::GetItems().end();
	 it++){
	const char *paired[3];
	paired[0]=   (*it)->VisualName().Char();
	paired[1]=   (*it)->ClassName().Char();
        DEBUG(3,"This class is %s\n",(*it)->ClassName().Char());
	paired[2] = 0;
	EntityList->rows().push_back(Gtk::SArray( paired ));
	EntityList->row(row).set_data((void*)(*it));
	row++;
    }
}

ConfigWindow::ConfigWindow() :
Gtk::Window(GTK_WINDOW_TOPLEVEL)
{
    DEBUG(5,"Creating Config Window\n");
    /*
     Gtk::MenuItem *save1 = manage(new class Gtk::MenuItem("_Save"));
     Gtk::MenuItem *quit1 = manage(new class Gtk::MenuItem("_Quit"));
     Gtk::Menu *File_menu = manage(new class Gtk::Menu());
     Gtk::MenuItem *File = manage(new class Gtk::MenuItem("_File"));
     menubar1 = manage(new class Gtk::MenuBar());
     */
    Gtk::Label *label27 = manage(new class Gtk::Label("All OK text:"));
    Gtk::Label *label28 = manage(new class Gtk::Label("Select text:"));
    Gtk::Label *label29 = manage(new class Gtk::Label("Error Text:"));
    CommonOKText = manage(new class Gtk::Entry());
    CommonSelectText = manage(new class Gtk::Entry());
    CommonErrorText = manage(new class Gtk::Entry());

    Gtk::Table *table2 = manage(new class Gtk::Table(3, 2, false));
    CommonCheckRun = manage(new class Gtk::CheckButton("Run Command on Failure:"));
    CommonTextEvent = manage(new class Gtk::Entry());
    Gtk::HBox *hbox6 = manage(new class Gtk::HBox(false, 0));
    Gtk::Label *label36 = manage(new class Gtk::Label("Command respawn time:"));
    Gtk::Adjustment *RespawnTime_adj = manage(new class Gtk::Adjustment(Config::NODE("fail")->
									PROPERTY("respawn")->
									VALUE().Integer(), 0, 10000, 1, 10, 10));
    RespawnTime = manage(new class Gtk::SpinButton(*RespawnTime_adj, 1, 0));
    Gtk::Label *label37 = manage(new class Gtk::Label("seconds"));
    Gtk::HBox *hbox20 = manage(new class Gtk::HBox(false, 0));
    Gtk::VBox *vbox6 = manage(new class Gtk::VBox(false, 0));
    Gtk::Label *label8 = manage(new class Gtk::Label("Common"));
    EntityList = manage(new class Gtk::CList(2));
    Gtk::ScrolledWindow *scrolledwindow5 = manage(new class Gtk::ScrolledWindow());
    Gtk::Button *EntityAddButton = manage(new class Gtk::Button("Add..."));
    Gtk::Button *EntityDeleteButton = manage(new class Gtk::Button("Delete"));
    Gtk::Button *EntityEditButton = manage(new class Gtk::Button("Edit..."));
    Gtk::VBox *vboxd = manage(new class Gtk::VBox(false, 0));
    Gtk::HBox *hbox19 = manage(new class Gtk::HBox(false, 0));
    Gtk::VBox *vbox10 = manage(new class Gtk::VBox(false, 0));
    Gtk::HBox *hbox18 = manage(new class Gtk::HBox(false, 0));
    Gtk::Label *label11 = manage(new class Gtk::Label("Entities"));


    Gtk::Notebook *notebook1 = manage(new class Gtk::Notebook());
    Gtk::VBox *vbox3 = manage(new class Gtk::VBox(false, 0));

    /*
     save1->set_name("save1");
     quit1->set_name("quit1");
     File_menu->set_name("File_menu");
     File_menu->append(*save1);
     File_menu->append(*quit1);
     File->set_name("File");
     File->set_submenu(*File_menu);
     menubar1->set_name("menubar1");
     menubar1->append(*File);
     */
    label27->set_name("label27");
    label27->set_alignment(0, 0.5);
    label27->set_padding(0, 0);
    label28->set_name("label28");
    label28->set_alignment(0, 0.5);
    label28->set_padding(0, 0);
    label29->set_name("label29");
    label29->set_alignment(0, 0.5);
    label29->set_padding(0, 0);
    CommonOKText->set_name("CommonOKText");
    CommonOKText->set_text(Config::NODE("text")->PROPERTY("oktext")->VALUE().Char());
    CommonOKText->set_editable(true);
    CommonSelectText->set_name("CommonSelectText");
    CommonSelectText->set_text(Config::NODE("text")->PROPERTY("selecttext")->VALUE().Char());
    CommonSelectText->set_editable(true);
    CommonErrorText->set_name("CommonErrorText");
    CommonErrorText->set_text(Config::NODE("text")->PROPERTY("errortext")->VALUE().Char());
    CommonErrorText->set_editable(true);
    table2->set_name("table2");
    table2->set_border_width(10);
    table2->set_col_spacings(5);
    table2->attach(*label27, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
    table2->attach(*label28, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
    table2->attach(*label29, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
    table2->attach(*CommonOKText, 1, 2, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
    table2->attach(*CommonSelectText, 1, 2, 1, 2, GTK_EXPAND|GTK_FILL, 0, 0, 0);
    table2->attach(*CommonErrorText, 1, 2, 2, 3, GTK_EXPAND|GTK_FILL, 0, 0, 0);
    CommonCheckRun->set_name("CommonCheckRun");
    CommonCheckRun->grab_focus();
    CommonTextEvent->set_name("CommonTextEvent");

    try {
	CommonCheckRun->set_active(Config::NODE("fail")->PROPERTY("enabled")->VALUE() == "1" ? 1:0);
    } catch (...) {
	CommonCheckRun->set_active(1);
    }

    try {
	CommonTextEvent->set_text(Config::NODE("fail")->PROPERTY("command")->VALUE());
	CommonTextEvent->set_editable(CommonCheckRun->get_active());
    } catch (...) {}

    hbox6->set_name("hbox6");
    hbox6->pack_start(*CommonCheckRun, false, false, 0);
    hbox6->pack_start(*CommonTextEvent);
    label36->set_name("label36");
    label36->set_alignment(0.5, 0.5);
    label36->set_padding(8, 0);
    RespawnTime->set_name("RespawnTime");
    RespawnTime->set_editable(true);
    label37->set_name("label37");
    label37->set_alignment(0.5, 0.5);
    label37->set_padding(0, 0);
    hbox20->set_name("hbox20");
    hbox20->pack_start(*label36, false, false, 0);
    hbox20->pack_start(*RespawnTime, false, false, 0);
    hbox20->pack_start(*label37, false, false, 0);
    vbox6->set_name("vbox6");
    vbox6->pack_start(*table2);
    vbox6->pack_start(*hbox6);
    vbox6->pack_start(*hbox20, true, false, 0);
    label8->set_name("label8");
    label8->set_alignment(0.5, 0.5);
    label8->set_padding(0, 0);
    EntityList->set_usize(270, -1);
    EntityList->set_name("EntityList");
    EntityList->set_column_title(0, "Name");
    EntityList->set_column_justification(0, GTK_JUSTIFY_LEFT);
    EntityList->set_column_width(0, 165);
    EntityList->set_column_title(1, "Class Type");
    EntityList->set_column_justification(1, GTK_JUSTIFY_LEFT);
    EntityList->set_column_width(1, 80);
    EntityList->column_titles_show();

    /*
     list<Entity*>::iterator it;
     int row = 0;
     for (it=App::GetItems().begin();
     it!=App::GetItems().end();
     it++){
     const char *paired[3];
     paired[0]=   (*it)->VisualName().Char();
     paired[1]=   (*it)->ClassName().Char();
     paired[2] = 0;
     EntityList->rows().push_back(Gtk::SArray( paired ));
     EntityList->row(row).set_data((void*)(*it));
     row++;

     }
     */
    ReloadEntities();

    scrolledwindow5->set_name("scrolledwindow5");
    scrolledwindow5->set_policy(GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
    scrolledwindow5->add(*EntityList);
    EntityAddButton->set_name("EntityAddButton");
    EntityDeleteButton->set_name("EntityDeleteButton");
    EntityEditButton->set_name("EntityEditButton");
    vboxd->set_name("vboxd");
    vboxd->pack_start(*EntityAddButton, false, false, 0);
    vboxd->pack_start(*EntityDeleteButton, false, false, 0);
    vboxd->pack_start(*EntityEditButton, false, false, 0);
    hbox19->set_name("hbox19");
    hbox19->pack_start(*vboxd);
    vbox10->set_name("vbox10");
    vbox10->pack_start(*hbox19);
    hbox18->set_name("hbox18");
    hbox18->pack_start(*scrolledwindow5);
    hbox18->pack_start(*vbox10);
    label11->set_name("label11");
    label11->set_alignment(0.5, 0.5);
    label11->set_padding(0, 0);
    notebook1->set_name("notebook1");
    notebook1->set_show_tabs(true);
    notebook1->set_tab_border(3);

    notebook1->pages().push_back(Gtk::Notebook_Helpers::TabElem(*vbox6, *label8));
    notebook1->pages().push_back(Gtk::Notebook_Helpers::TabElem(*hbox18, *label11));

    /* Push all entities to notebook */
    DEBUG(5,"Locating classes\n");
    ClassList::const_iterator cit;
    for (cit=Config::ClassesBegin();
	 cit!=Config::ClassesEnd();
	 cit++) {
	Gtk::Box *b = 0;
	//b = (*cit)->NotebookPage();
	// TODO: free ConfigurableList after use (done)
	ConfigurableItemList *lst = (*cit)->Config();
	items[*cit] = lst;
	if (lst) {
	    b = build_from_citemlist( lst );
	    if (b) {
		notebook1->pages().push_back(Gtk::Notebook_Helpers::TabElem(*b, (*cit)->VisualName()));
		b->show();
	    }
	}
	DEBUG(5,"Class Loaded.\n");
    }
    DEBUG(5,"All Classes Loaded\n");



    Gtk::Button *okButton = manage(new class Gtk::Button("OK"));
    Gtk::Button *cancelButton = manage(new class Gtk::Button("Cancel"));
    Gtk::Box *bhbox = manage(new class Gtk::HBox(false, 0));
    bhbox->pack_start(*okButton);
    bhbox->pack_start(*cancelButton);
    //   notebook1->pages().push_back(Gtk::Notebook_Helpers::TabElem(*vbox7, *PingerLabel));
    vbox3->set_name("vbox3");
    /*
     vbox3->pack_start(*menubar1, false, false, 0);
     */

    vbox3->pack_start(*notebook1);
    vbox3->pack_start(*bhbox, false, false, 0);

    set_usize(450, 250);
    set_name("ConfigWindow");
    set_title("MonitorIT! Configuration");
    set_policy(false, false, false);
    add(*vbox3);

    /*  save1->show();
     quit1->show();
     File_menu->show();
     File->show();
     menubar1->show();
     */
    label27->show();
    label28->show();
    label29->show();
    CommonOKText->show();
    CommonSelectText->show();
    CommonErrorText->show();
    table2->show();
    CommonCheckRun->show();
    CommonTextEvent->show();
    hbox6->show();
    label36->show();
    RespawnTime->show();
    label37->show();
    hbox20->show();
    vbox6->show();
    label8->show();
    EntityList->show();
    scrolledwindow5->show();
    EntityAddButton->show();
    EntityDeleteButton->show();
    EntityEditButton->show();
    vboxd->show();
    hbox19->show();
    vbox10->show();
    hbox18->show();
    label11->show();

    notebook1->show();
    vbox3->show();
    okButton->show();
    cancelButton->show();
    bhbox->show();
    notebook1->switch_page( *(notebook1->pages().begin()++) );
    show();

    /*   save1->activate.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_save1_activate));
     quit1->activate.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_quit1_activate));
     */
    CommonOKText->changed.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_CommonOKText_changed));
    CommonSelectText->changed.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_CommonSelectText_changed));
    CommonErrorText->changed.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_CommonErrorText_changed));
    CommonCheckRun->toggled.connect(SigC::bind(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_CommonCheckRun_toggled), (const gchar*)"CommonTextEvent"));
    CommonTextEvent->changed.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_CommonTextEvent_changed));
    RespawnTime->changed.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_RespawnTime_changed));
    EntityList->select_row.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_EntityList_select_row));
    EntityList->unselect_row.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_EntityList_unselect_row));
    EntityAddButton->clicked.connect(SigC::bind(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_add_button_clicked), (const gchar*)"EntityList"));
    EntityDeleteButton->clicked.connect(SigC::bind(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_EntityDeleteButton_clicked), (const gchar*)"EntityList"));
    EntityEditButton->clicked.connect(SigC::bind(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_EntityEditButton_clicked), (const gchar*)"EntityList"));

    focus_in_event.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_ConfigWindow_focus_in_event));
    delete_event.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_ConfigWindow_delete_event));
    okButton->clicked.connect(SigC::slot(static_cast<class ConfigWindow*>(this), &ConfigWindow::on_okButton_clicked));
    cancelButton->clicked.connect(SigC::slot(this, &ConfigWindow::on_cancelButton_clicked));
}

void ConfigWindow::SetCloseNotify(const SigC::Slot1<void,void*> &func, void *arg)
{
    DEBUG(5,"Setting Close Notify");
    close_notify=func;
    cndata=arg;
}

ConfigWindow::~ConfigWindow()
{
}

void ConfigWindow::SaveData()
{
    *Config::NODE("text")->PROPERTY("selecttext") =
        CommonSelectText->get_text();
    *Config::NODE("text")->PROPERTY("oktext") =
        CommonOKText->get_text();
    *Config::NODE("text")->PROPERTY("errortext") =
        CommonErrorText->get_text();
    *Config::NODE("fail")->NewPROPERTY("command") =
	CommonTextEvent->get_text();
    *Config::NODE("fail")->PROPERTY("enabled") =
	CommonCheckRun->get_active() ? "1" : "0";
    *Config::NODE("fail")->PROPERTY("respawn") =
	RespawnTime->get_value_as_int();


    DEBUG(5,"Propagating SaveData\n");
    ClassList::const_iterator cit;
    for (cit=Config::ClassesBegin();
	 cit!=Config::ClassesEnd();
	 cit++) {
	ConfigurableItemList *lst ;
	lst = items[*cit];
	if (lst) {
	    (*cit)->ApplyConfig(lst);
            delete( lst );
	}
    }
    DEBUG(5,"Propagate done\n");

    Config::Save();
}

void ConfigWindow::on_ChooseClassCancel_clicked(Gtk::Widget *w)
{
    w->destroy();
}
void ConfigWindow::on_ChooseClassOK_clicked( Gtk::Combo *combo, Gtk::Widget *w)
{
    Gtk::Entry *entry = combo->get_entry();
    DEBUG(1,"Selected %s\n", entry->get_text().c_str());
    ClassList::const_iterator cit;
    for (cit=Config::ClassesBegin();
	 cit!=Config::ClassesEnd();
	 cit++) {
	if ( (*cit)->VisualName() == entry->get_text()) {
            AddEntity( (*cit) );
	}
    }
    w->destroy();
}
void ConfigWindow::AddEntity( Configurable *c )
{
    ConfigurableItemList *l = c->Add();
    createWindow( l, NULL, c, slot( this, &ConfigWindow::on_APEOKButton_clicked_ADD ));

}

void ConfigWindow::ChooseClass( )
{
    
    Gtk::Window *w;
    Gtk::Button *ok, *cancel;
    Gtk::Combo *combo;
    Gtk::Label *label;
    Gtk::VBox *box;
    Gtk::HBox *hbox;

    w =  manage ( new Gtk::Window(GTK_WINDOW_DIALOG) );
    ok =  manage ( new Gtk::Button("OK") );
    cancel =  manage ( new Gtk::Button("Cancel") );
    label =   manage ( new Gtk::Label("Select class type:") );
    combo =    manage ( new Gtk::Combo() );
    box =      manage ( new Gtk::VBox(false, 0) );
    hbox =      manage ( new Gtk::HBox(false, 0) );

    list<string> ls;

    ClassList::const_iterator cit;
    for (cit=Config::ClassesBegin();
	 cit!=Config::ClassesEnd();
	 cit++) {
	ls.push_back( (*cit)->VisualName() );
    }

    Gtk::SArray array(ls);

    combo->set_popdown_strings( array );
    combo->set_value_in_list(true,false);
    box->pack_start( *label, true, true, 0 );
    box->pack_start( *combo, true, true, 0 );
    hbox->pack_start( *ok, true, true, 0 );
    hbox->pack_start( *cancel, true, true, 0 );
    box->pack_start( *hbox, true, true, 0 );

    w->add( *box );
    w->set_modal( true );
    w->set_title("Select class type");
    box->show();
    hbox->show();
    label->show();
    combo->show();
    ok->show();
    cancel->show();

    cancel->clicked.connect(
			SigC::bind(
				   SigC::slot(static_cast<ConfigWindow*>(this),
					      &ConfigWindow::on_ChooseClassCancel_clicked),
				   w
				  )
		       );

    ok->clicked.connect(
			SigC::bind(
				   SigC::slot(static_cast<ConfigWindow*>(this),
					      &ConfigWindow::on_ChooseClassOK_clicked),
				   combo,
                                   w
				  )
		       );


    w->show();
}


#include "ConfigItem.h"


void ConfigWindow::parse_single( ConfigurableItem *item , Gtk::Box *container)
{

    if (item->get_type() == "group") {
	CItemGroup *group = static_cast<CItemGroup*>(item);

	Gtk::Box *c2 = manage( new class Gtk::VBox(  ) );

	Gtk::Frame *Frame = manage(new class Gtk::Frame( group->name() ));

	Frame->add ( *c2 );

	CItemGroup::iterator it2;

	for (it2= group->begin();
	     it2!= group->end();
	     it2++) {
	    parse_single( *it2, c2 );
	}

	container->pack_start( *Frame, true, false, 0);

	Frame->show();
	c2->show();
    }



    if (item->get_type() == "string") {
	CItemString *s = static_cast<CItemString*> (item);
	Gtk::Box *Box = manage( new class Gtk::HBox( ) );
	Gtk::Label *Label = manage(new class Gtk::Label( s->name() ));
	Gtk::Entry *Entry = manage(new class Gtk::Entry());

	Entry->set_text( s->value() );

	if (s->isDependable()) {
	    CItemDependable<CItemString> *dep = static_cast< CItemDependable<CItemString> * > (s);

	    //	    Gtk::Label *Label2 = manage(new class Gtk::Label( dep->getDependable()->name() ));
	    Gtk::CheckButton *Button = manage(new class Gtk::CheckButton(dep->getDependable()->name(),0,0.5));
	    Button->set_active( dep->getDependable()->value() == "true" );

	    Box->pack_start( *Button, true, false, 0);

	    CItemBoolean *booli = dep->getDependable();
	    DEBUG(9,"Dependable %p\n", booli);

	    pair<Gtk::Widget *, CItemBoolean *> *ppair =
	    new pair<Gtk::Widget *, CItemBoolean *>(Entry , booli);

	    Button->toggled.connect(
			      SigC::bind(
					 SigC::slot(static_cast<ConfigWindow*>(this),
						    &ConfigWindow::Dependable_Toggle),
					 Button,
					 ppair
					)
				   );
	    Button->destroy.connect(
				    SigC::bind(
					       SigC::slot(static_cast<ConfigWindow*>(this),
							  &ConfigWindow::Dependable_Destroy),
					       ppair
					      )
				   );


	    Button->show();
	}

	Box->pack_start( *Label, true, false, 0 );
	Box->pack_start( *Entry, true, false, 0 );

	container->pack_start( *Box, true, false, 0 );

	Entry->changed.connect(
			       SigC::bind(
					  SigC::slot(static_cast<ConfigWindow*>(this),
						     &ConfigWindow::Entry_Changed),
					  Entry,
					  s)
			      );


	Box->show();
	Entry->show();
	Label->show();

    }

    if (item->get_type() == "boolean") {
	CItemBoolean *s = static_cast<CItemBoolean*> (item);
	Gtk::Box *Box = manage( new class Gtk::HBox( ) );


	Gtk::CheckButton *Button = manage(new class Gtk::CheckButton(s->name(),0,0.5));

	DEBUG(1,"Boolean value of %s is %s\n", s->id().c_str(), s->value().c_str());
	Button->set_active( s->value() == "true" );

	if (s->isDependable()) {
	    CItemDependable<CItemBoolean> *dep = static_cast< CItemDependable<CItemBoolean> * > (s);
	    Gtk::CheckButton *Button2 = manage(new class Gtk::CheckButton(dep->getDependable()->name(),0,0.5));
	    Box->pack_start( *Button2, true, false, 0);
	    Button2->set_active( dep->getDependable()->value() == "true" );
	    DEBUG(1,"Boolean value of %s is %s\n", dep->id().c_str(), dep->value().c_str());
	    if (Button2->get_active()) {
		Button->set_flags(GTK_SENSITIVE);
		Button->set_state(GTK_STATE_NORMAL);
	    } else {
		Button->set_state(GTK_STATE_INSENSITIVE);
	    }
	    CItemBoolean *booli = dep->getDependable();
	    DEBUG(9,"Dependable %p\n", booli);

	    pair<Gtk::Widget *, CItemBoolean *> *ppair =
	    new pair<Gtk::Widget *, CItemBoolean *>(Button , booli);

	    Button2->toggled.connect(
			      SigC::bind(
					 SigC::slot(static_cast<ConfigWindow*>(this),
						    &ConfigWindow::Dependable_Toggle),
					 Button2,
					 ppair
					)
				   );
	    Button2->destroy.connect(
				    SigC::bind(
					       SigC::slot(static_cast<ConfigWindow*>(this),
							  &ConfigWindow::Dependable_Destroy),
					       ppair
					      )
				   );

	    Button2->show();
	}
	Box->pack_start( *Button, true, false, 0 );

	Button->toggled.connect(
				SigC::bind(
					   SigC::slot(static_cast<ConfigWindow*>(this),
						      &ConfigWindow::Check_Changed),
					   Button,
					   s)
			       );


	Button->show();
	container->pack_start( *Box, true, false, 0 );
	Box->show();
    }

    if (item->get_type() == "integer") {
	CItemInteger *s = static_cast<CItemInteger*> (item);
	Gtk::Box *Box = manage( new class Gtk::HBox( ) );
	Gtk::Label *Label = manage(new class Gtk::Label( s->name() ));

	Gtk::Adjustment *Adjust = manage(new class Gtk::Adjustment(strint(s->value()), s->minimum(), s->maximum(),
								   1, 10, 10));
	Gtk::SpinButton *Spin = manage(new class Gtk::SpinButton(*Adjust, 1, 0));

	if (s->isDependable()) {
	    CItemDependable<CItemInteger> *dep = static_cast< CItemDependable<CItemInteger> * > (s);
            
	    Gtk::CheckButton *Button = manage(new class Gtk::CheckButton(dep->getDependable()->name(),0,0.5));

	    Button->set_active( dep->getDependable()->value() == "true" );
	    DEBUG(1,"Boolean value of %s is %s\n", dep->id().c_str(), dep->value().c_str());
	    Box->pack_start( *Button, true, false, 0);
	    if (Button->get_active()) {
		Spin->set_flags(GTK_SENSITIVE);
		Spin->set_state(GTK_STATE_NORMAL);
	    } else {
		Spin->set_state(GTK_STATE_INSENSITIVE);
	    }


	    CItemBoolean *booli = dep->getDependable();
	    DEBUG(9,"Dependable %p\n", booli);

	    pair<Gtk::Widget *, CItemBoolean *> *ppair =
	    new pair<Gtk::Widget *, CItemBoolean *>(Spin , booli);

	    Button->toggled.connect(
			      SigC::bind(
					 SigC::slot(static_cast<ConfigWindow*>(this),
						    &ConfigWindow::Dependable_Toggle),
					 Button,
					 ppair
					)
				   );
	    Button->destroy.connect(
				    SigC::bind(
					       SigC::slot(static_cast<ConfigWindow*>(this),
							  &ConfigWindow::Dependable_Destroy),
					       ppair
					      )
				   );


	    Button->show();
	}

	Box->pack_start( *Label, true,false, 0 );
	Box->pack_start( *Spin, true, false , 0 );
	if ( s->units().length() > 0) {
	    Gtk::Label *Units =  manage(new class Gtk::Label( s->units() ));
	    Box->pack_start( *Units, true,false, 0 );
	    Units->show();
	}

	container->pack_start( *Box, true,false, 0 );

	Spin->changed.connect(
			      SigC::bind(
					 SigC::slot(static_cast<ConfigWindow*>(this),
						    &ConfigWindow::Spin_Changed),
					 Spin,
					 s)
			     );
	Box->show();
	Spin->show();
	Label->show();
    }
}

Gtk::Box * ConfigWindow::build_from_citemlist(const ConfigurableItemList *list)
{
    DEBUG(5,"Parsing Item List\n");
    ConfigurableItemList::const_iterator it;
    Gtk::Box *container = manage( new class Gtk::VBox( ) );

    for (it = list->begin();
	 it!= list->end();
	 it++) {
	parse_single( *it, container );
    }
    DEBUG(5,"Parsing Item List Completed\n");
    return container;
}

void ConfigWindow::messageEnd( Gtk::Window *w)
{
    w->destroy();
}

void ConfigWindow::message(const string &s)
{
    GList *glist = new GList();
    Gtk::Window *w = manage( new Gtk::Window(GTK_WINDOW_DIALOG) );
    Gtk::VBox *b = manage( new Gtk::VBox(false, 10) );
    Gtk::Button *Button =  manage ( new Gtk::Button("OK") );
    Gtk::Label *Label = manage( new Gtk::Label( s ) );
    Label->set_line_wrap(true);
    b->set_border_width(10);

    b->pack_start( *Label, true, true, 0 );
    b->pack_start( *Button, true, true,0 );

    Button->clicked.connect( SigC::bind(SigC::slot( this, &ConfigWindow::messageEnd),
					w));
    

    w->add( *b );

    b->show();
    Label->show();
    Button->show();
    w->set_modal( true );
    w->show();
}
