/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __APP_H__
#define __APP_H__

#include "Entity.h"
#include <list>
#include "DString.h"
#include "config.h"
#include "Config.h"

#ifdef HAVE_GTK

#include <sigc++/bind.h>
#include "../gtkconfig/GCMain.h"

namespace Gtk
{
    class Widget;
}
class App: public SigC::Object
#else
class App
#endif
{
public:
    static void Init();
    virtual void Configure() = 0;
    virtual void Add(Entity&) = 0;
    virtual void IFail(Entity*) = 0;
    virtual void IDoNotFail(Entity*) = 0;
    virtual void Run() = 0;
    virtual void Close() = 0;
    static void chld_signal(int sig);
    //    static int periodic(void*);
    void periodic();
    static list<Entity*> &GetItems() { return Items; }
    virtual ~App() {};
protected:
    static list<Entity*> Items;
    list<Entity*> FailItems;
    static dstring failcommand;
    static int ptime;
    static int command_running;
    static int failures;
#ifdef HAVE_GTK
    ConfigWindow *cw;
    static int configuring;
#endif
};

#endif
