/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __DSTRING_H__
#define __DSTRING_H__

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include "Error.h"
#include <string>


class dstring: public string
{
public:

    dstring(): string() {};
    dstring(const char*c):	string(c) {};
    dstring(const string &c):	string(c) {};
    dstring(int a): string() {
	static char tmp[80];
	sprintf(tmp, "%d", a);
	(*this) = tmp;
    }

        /*
    dstring(const dstring&);
    ~dstring();

    dstring & operator +(const dstring&);
    dstring & operator +(const char*);
    */
    //dstring & operator =(const string&);
    /*
    dstring & operator =(const char *);
    dstring & operator +=(const char *);
    dstring & operator +=(const dstring&);

    bool operator==(const char*);
    bool operator==(const dstring &a) { return (*this)==a.Char(); }
    */
    dstring substr(int start, int size) const {
	return string::substr(start,size);
    }
    const char *Char() const { return c_str(); }
    /*
    void Clear();
    int Size() const { return size; }
    */
    int Integer() const {
	long l;
	l = strtol(c_str(), (char**)0, 10);
	if (l==LONG_MIN || l==LONG_MAX)
	    throw Error("NaN");
        return (int)l;
    }

	    const dstring &operator()() const { return *this; }
    /*
    dstring substr(int start, int ssize) const ;
    char operator[](int) const ;
    dstring& crop(int ssize);
    int index(int start, char ch) const ;
protected:
    void append(const char *);
    char *buf;
    int bufsize;
    int size;
    */
};

class dstringhasher
{
public:
    size_t operator() (dstring const &s) const {
	size_t hash=0x5555;
	const char *p=s.c_str();
	for (;*p;p++) hash = (hash<<2) ^ tolower(*p);
	if (hash<0) return -hash;
	return hash;
    }
};

class dstringtokenizer
{
public:
    dstringtokenizer(const dstring&, const dstring &tokens);
    bool end();
    dstring next();
    dstring next(const dstring &tokens);
    int count();
    unsigned char last_delimiter();
private:
    dstring tokens;
    dstring str;
    int position;
};

int toint(const dstring&s);

#include <hash_map>

class dstringhash: public hash_map<dstring, dstring, dstringhasher>
{
};


#endif
