/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __ENTITY_H__
#define __ENTITY_H__

#include "config.h"
#include "DString.h"
#include "ConfigItem.h"
//#include <netinet/in.h>
/*
#ifdef HAVE_GTK
#include <sigc++/slot.h>

namespace Gtk {
    class Box;
    class Label;
};

#endif
*/
class Led;
class Configurable;
class ConfigurableItemList;

class Entity
{
public:
    Entity(const dstring &h, const dstring& v, Led *w, Configurable *_c);
    virtual ~Entity() {}
    virtual void FindHost(const char *hostname, struct sockaddr_in& s);
    dstring VisualName() { return visualname; }
    void IFail();
    void IDoNotFail();
    void MoveTo(int xx,int yy);
    virtual Led &GetLed();
    virtual void LeftClick();
    virtual void RightClick();
    virtual void MiddleClick();
    virtual const dstring ClassName() = 0;
    virtual const dstring &HostName() { return hostname; }
    virtual void SetHostName(const dstring&s) { hostname=s;};
    virtual Configurable *Class() { return _class; }
    virtual ConfigurableItemList * Edit();

protected:
    int fail;
    dstring hostname,visualname;
    Led *widget;
    Configurable *_class;
};

#endif
