/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __LED_H__
#define __LED_H__

#include <list>

class Entity;

class LedConfig
{
public:
};


typedef enum {
    LED_RED=0,
    LED_GREEN=1,
    LED_OFF=2,
    LED_YELLOW=3,
    LED_BLUE=4,
    LED_PURPLE=5
} LedColor;

class Led
{
public:
    Led(): color(LED_OFF), c1(LED_RED) {}
    //Led(VisualInterface &v);
    void SetColor(LedColor c) { if (color!=c) {color=c; c1=c; Redraw(); } }
    void SetTempColor(LedColor c) { color=c; }
    void SetTrueColor() { color=c1; }
    LedColor GetColor() { return color; }
    virtual int SetFlash(bool b) = 0;
    virtual void Redraw() = 0;
    virtual void MoveTo(int,int) = 0;
    virtual void IFail(Entity*) = 0;
    virtual void IDoNotFail(Entity*) = 0;
protected:
    LedColor color, c1;
    bool flashing;
    static list<Led*> Flash;
    static int timeoutid;
};

#endif
