/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __VISUAL_H__
#define __VISUAL_H__

//#include "Entity.h"
#include <TimeVal.h>
#include "Timeout.h"
#include "config.h"
#include <sigc++/slot.h>
#include <string>
#include <vector>

class Entity;
class Led;
/*
#ifndef HAVE_GTK
 */
const int FDREAD = 1;
const int FDWRITE = 2;
const int FDEXCP = 3;

#define FDTYPE int
/*
#else
#include <gdk/gdk.h>
#define FDREAD GDK_INPUT_READ
#define FDWRITE GDK_INPUT_WRITE
#define FDEXCP GDK_INPUT_EXCEPTION

#define FDTYPE GdkInputCondition

#endif
*/

typedef SigC::Slot2<void, int, int> ExecCallback;

class VisualInterface
{
    typedef SigC::Slot1<void, int> FDChangedHandler;
public:
    virtual ~VisualInterface() {};
    virtual int Open(int argc, char **argv,int,int) = 0;
    virtual int CloseVisual() = 0;
    virtual int RunVisual() = 0;
    //   virtual int WatchFD(int fd, FDTYPE fdtype, const FDChangedHandler handler,void *data) = 0;
    virtual int Exec(const string &command,
                     const vector<string> &args,
		     const ExecCallback &) = 0;
    virtual int WatchFD(int fd, FDTYPE fdtype, const SigC::Slot1<void, int> &) = 0;
    virtual int StopWatch( int) = 0;
    virtual const char *Type() = 0;
    virtual void IFail(Entity*) = 0;
    virtual void IDoNotFail(Entity*) = 0;
    virtual Led* NewLed() = 0;
    virtual int RequestPeriodicTimeout(long seconds, long milisseconds,
				       const SigC::Slot0<void> &) = 0;
    virtual int CancelTimeout(int) = 0;
};

#endif
