/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __DEBUG_H__
#define __DEBUG_H__

#include "config.h"
#include <stdio.h>

#if !(defined (G_STMT_START) && defined (G_STMT_END))
#  if defined (__GNUC__) && !defined (__STRICT_ANSI__) && !defined (__cplusplus)
#    define G_STMT_START	(void)(
#    define G_STMT_END		)
#  else
#    if (defined (sun) || defined (__sun__))
#      define G_STMT_START	if (1)
#      define G_STMT_END	else (void)0
#    else
#      define G_STMT_START	do
#      define G_STMT_END	while (0)
#    endif
#  endif
#endif

#ifdef DEBUG_ENABLED

struct MonitorDEBUG {
 static int debuglevel;
};

#ifdef __GNUC__

#define DEBUG(level, expr... )        G_STMT_START{		\
    if (level<=MonitorDEBUG::debuglevel) {     				      \
    fprintf(stderr,"%s:%s [%d]: ",	\
    __FILE__,						\
    __PRETTY_FUNCTION__,\
    __LINE__ \
    );\
    fprintf(stderr, expr);}\
    }G_STMT_END
#else
#define DEBUG(level, expr...)        G_STMT_START{		\
    if (level<=MonitorDEBUG::debuglevel)					      \
    fprintf(stderr,"%s [%d]: %s",	\
    __FILE__,						\
    __LINE__ ); \
    fprintf(stderr, expr);\
    }G_STMT_END

#endif /* __GNUC__ */

#else
#define DEBUG(level,expr...)
#endif /* DEBUG_ENABLED */

#endif


