/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __GTKAPP_H__
#define __GTKAPP_H__

#include "App.h"
#include "GTKVisual.h"
#include "GTKLed.h"
#include "GTKFixed.h"
#include "GTKText.h"
//#include "GTKText.h"
#include <sys/signal.h>


namespace Gtk {
    class Fixed;
    class DrawingArea;
};

class GTKApp: public App, public GTKInterface
{
public:
    GTKApp(int argc, char **argv);
   // virtual void HandleEvent(XEvent&event);
    virtual void IDoNotFail(Entity*);
    virtual void IFail(Entity*);
    virtual void Add(Entity &);
    virtual void Configure();
    void Run() {  GTKInterface::RunVisual(); }
    void Close(){  GTKInterface::CloseVisual();}
    virtual ~GTKApp();
    static void chld_signal(int sig);
/*    static int periodic(void*); */
    void AttachConfigure(Gtk::Widget *(*ccw)());
protected:
   // GTKText *textarea;
    ///GTKDrawingArea *displayarea;

    int EnterLedArea(GdkEventCrossing*);
    int LeaveLedArea(GdkEventCrossing*);
    int EnterLed(GdkEventCrossing*,Entity*);
    int LeaveLed(GdkEventCrossing*,Entity*);
    int ButtonPressLed(GdkEventButton*, Entity*);
    int ButtonReleaseLed(GdkEventButton*, Entity*);
    int LedAreaClick(GdkEventButton*);
    void ConfigEnd(void *);
    /*static void ConfigEnd(void*d) {
	((GTKApp*)d)->ConfigEnd(d);
    }   */
    void RunConfig();

    char *shapemaskbits;
    int failures;
    int cx,cy;
    GTKLedConfig *lc;
    GTKFixed *led_area;

    GTKText *text_area;
    typedef ConfigWindow *(*Configurator)();
    ConfigWindow *MyConfigWindow;
    ConfigWindow *(*CreateConfigWindow)();
    Gtk::Style *style;
};

#endif
