/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __GTKLED_H__
#define __GTKLED_H__

#include "Led.h"
#include "GTKWidget.h"
// #include <gtk--/bin.h>
#include <gtk--/pixmap.h>
//#include <gtk--/button.h>
#include "GTKVisual.h"

class GTKLedConfig: public LedConfig
{
public:
    GTKLedConfig(GTKInterface &visual,const char *filename,int sx,int sy, int w, int h);
    /*LedConfig(VisualInterface &,const char *filename,
     int x, int y, int width, int height);
     */
    static Gdk_Pixmap all_leds;
    static Gdk_Bitmap leds_mask;
    static int xpm_x, xpm_y;
    static int width, height;
};

class GTKLed: public Led, public Gtk::DrawingArea, public GTKWidget
{
public:
    GTKLed(GTKInterface&);
    //void RedrawAll(int x,int y);// { GTKWidget::RedrawAll(x,y); }
    void DrawAt(int x, int y);// { GTKWidget::DrawAt(x,y); }
    int SetFlash(bool);
    void DoFlash(void);
    virtual void Redraw();
    virtual void MoveTo(int,int) {};
    virtual void IFail(Entity*e);
    virtual void IDoNotFail(Entity*e);
    virtual int Width() { return GTKLedConfig::width; }
    virtual int Height() { return GTKLedConfig::height; }
protected:
    virtual gint expose_event_impl(GdkEventExpose*);
    static int initialized;
    int flashing, color, c1,c2;
    //GTKInterface *visual;
};

/*
class GTKLed_Class
{
public:

    typedef Led               CppObjectType;
    typedef GTKLed            BaseObjectType;
    typedef GTKLed_Class      BaseClassType;
    typedef Gtk::Widget_Class CppClassParent;
    typedef GtkWidgetClass    BaseClassParent;

    static void class_init_function(BaseClassType *p);
    static void object_init_function(BaseObjectType *o);
    GtkType get_type();

    // Hook for translating API
    static Gtk::Object* wrap_new(GtkObject*);

    // Callbacks here...

    // Data
    GtkType type;
};

  */



#endif